////////////////////////////////////////////////////////////////////////////////
//
// Test programmer's method on one file.
//
////////////////////////////////////////////////////////////////////////////////


import java.io.*;
import java.util.*;

import edu.cmu.cs.pattis.cs151xx.*;



public class Test {


  public static void testOne (String name)
  {
    try {
      System.out.println ("Testing: " + name.substring(Menu.inputDirectory.length() + Menu.sepLen));
      TypedBufferReader tbr = new TypedBufferReader("\""+name);
       
      //Read and print comment line
      String line = tbr.readLine();
      System.out.println ("Comment: " +line);
      System.out.println ();

      //Read input and build structure
      ExtendedLL original = new ExtendedLL();
      while (true) {
        String value = tbr.readLine(); 
        if (value.equals("*"))
          break;
        original.addFirst(value);
      }

      //Read input and build structure
      ExtendedLL other = new ExtendedLL();
      while (true) {
        String value = tbr.readLine(); 
        if (value.equals("*"))
          break;
        other.addFirst(value);
      }

      //Read correct output
      List correct = new ArrayList();
      while (true) {
        String value = tbr.readLine(); 
        if (value.equals("*"))
          break;
        correct.add(value);
      }
      
      //Print input (as tree)
      System.out.println ("Original List:  " + original);
      System.out.println (); 
      
      //UPDATE METHOD CALL
      System.out.println ("Other    List:  " + other);
      System.out.println (); 

      //Print user answer
      System.out.println ("Student Output (in original but not other): " + original.getItemsNotPresent(other));
      System.out.println (); 
      
      //If no output files, print answer here
      if ( !(new File("output")).isDirectory() ) {
        System.out.print ("Correct Output                            : ");
        for (int i=0; i<correct.size(); i++)
          System.out.println(correct.get(i));
        System.out.println (); 
      }

      System.out.println (); 
      System.out.println (); 
   }
   catch (Exception e) {   
     e.printStackTrace();
   }
  }


  public static void main (String[] args)
  {
    for(;;)
      //UPDATE METHOD NAME
      for (StringTokenizer st = new StringTokenizer(Menu.getFiles("Test Menu For 'getItemsNotPresent'")); st.hasMoreTokens(); )
        testOne(st.nextToken());
  }

}
